            #GIT_CMT=f8fa67207ba642261a9475b4aba593ebd47a614f
%global debug_package %{nil}
%global python_ver python2 

#
# Example ARCHIVE Generation:
# export COMMIT=b6e48ec6
# export VERSION=20191205
# export RELEASE=1.el8
# rpmdev-setuptree
# git-archive-all --prefix edk2-${VERSION}/ ~/rpmbuild/SOURCES/edk2-${RELEASE}.tar.gz
#
# Copy over patches/files:
# cp buildrpm/ol8/* ~/rpmbuild/SOURCES
#
# Build the RPMs:
# rpmbuild -ba buildrpm/ol8/edk2.spec
#
Name:		edk2
Version:	20201203
Release:    1.el8
Epoch:		1
Summary:	UEFI Firmware for 64-bit virtual machines

Group:		Applications/Emulators
License:	BSD and OpenSSL
URL:		http://www.tianocore.org
Source0: edk2-20201203.tar.bz2
Source1:	ovmf-vars-generator
Source2:	aavmf-vars-generator
Source3:	OpenSSL-1.1.g-e2e09d9fba1187f8d6aafaa34d4172f56f1ffb72.tgz
Source4:	BaseTools-BrotliCompress-666c3280cc11dc433c303d79a83d4ffbdd12cc8d.tgz
Source5:	MdeModulePkg-BrotliCustomDecompressLib-666c3280cc11dc433c303d79a83d4ffbdd12cc8d.tgz
Source6:	OVMF_CODE.enrollment.fd

Patch4:		0001-MdeModulePkg-TerminalDxe-add-other-text-resolutions.patch
Patch5:		0002-EXCLUDE_SHELL_FROM_FD.patch

Patch10:	0001-OvmfPkg-SmbiosPlatformDxe-install-legacy-QEMU-tables.patch
Patch11:	0002-OvmfPkg-SmbiosPlatformDxe-install-patch-default-lega.patch
Patch12:	0003-OvmfPkg-SmbiosPlatformDxe-install-patch-default-lega.patch

Patch20:	0006-OvmfPkg-EnrollDefaultKeys-application-for-enrolling-.patch

Patch30:	0001-tools_def.template-take-GCC4-_-IA32-X64-prefixes-fro.patch

Patch40:	0001-MdeModulePkg-silence-image-start-error.patch
Patch50:	0002-OvmfPkgX64-DSC-Updates.patch
Patch51:	0001-ArmVirtPkg-DSC-Updates.patch
Patch60:	0002-Smbios-ovmf-version-update.patch
Patch70:	0001-Bug31156337-Connect-MassStorage-WAR.patch
Patch80:	0001-Silence-BootOption-Load-Errors.patch
Patch90:	0001-GenericQemuLoadImageLib-Compile-error1.patch
Patch91:	0001-HttpDynamicCommand-Compile-error1.patch
Patch92:	0001-MdeModulePkg-AhciMode-Compile-error1.patch
Patch100:	0001-ArmVirtPkg-EnrollDefaultKeys-application-for-enrolling-.patch
Patch105:	0001-ArmPlatformPkg-NorFlashDxe-Allow_Readonly.patch
Patch110:	0001-SecurityPkg-Disable-Secureboot-User-Config.patch
Patch120:	0001-SecureBoot-Logging1.patch

BuildRequires:	mtools
BuildRequires:	dosfstools
BuildRequires:	genisoimage
BuildRequires:	iasl
BuildRequires:	python2
BuildRequires:	libuuid-devel
BuildRequires:	git
# For generating the variable store template with the
# default certificates enrolled, we need qemu.
BuildRequires:  qemu-kvm-core
%ifarch x86_64
BuildRequires:	nasm
%endif

%description
EFI Development Kit II

%package tools
Summary:	EFI Development Kit II Tools
%description tools
EFI Development Kit II Tools


%ifarch x86_64
%global subpkgname ovmf

%package ovmf 
Summary:	UEFI Firmware for 64-bit virtual machines
License:	BSD and OpenSSL
BuildArch:      noarch

%description ovmf
UEFI Firmware for 64-bit virtual machines
%endif


%ifarch aarch64
%global subpkgname aarch64

%package aarch64 
Summary:	UEFI Firmware for aarch64 virtual machines
License:	BSD
BuildArch:      noarch

%description aarch64 
UEFI Firmware for aarch64 virtual machines
%endif

%prep
%setup -q -n %{name}-%{version}

%patch4 -p1
%patch5 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch20 -p1
%patch30 -p1
%patch40 -p1
%patch50 -p1
%patch51 -p1
%patch60 -p1
%patch70 -p1
%patch80 -p1
%patch90 -p1
%patch91 -p1
%patch92 -p1
%patch100 -p1
%patch105 -p1
%patch110 -p1
%patch120 -p1


cp -a -- %{SOURCE1} .
cp -a -- %{SOURCE2} .
cp -a -- %{SOURCE3} .
cp -a -- %{SOURCE4} .
cp -a -- %{SOURCE5} .
cp -a -- %{SOURCE6} .

tar xfz OpenSSL-1.1.g-e2e09d9fba1187f8d6aafaa34d4172f56f1ffb72.tgz -C CryptoPkg/Library/OpensslLib/
tar xfz BaseTools-BrotliCompress-666c3280cc11dc433c303d79a83d4ffbdd12cc8d.tgz -C BaseTools/Source/C/BrotliCompress
tar xfz MdeModulePkg-BrotliCustomDecompressLib-666c3280cc11dc433c303d79a83d4ffbdd12cc8d.tgz -C MdeModulePkg/Library/BrotliCustomDecompressLib

%build
# specify the proper python for use by the edk build system
PYTHON_COMMAND=%{python_ver}
export PYTHON_COMMAND
source ./edksetup.sh

# figure tools switch
GCCVER=$(gcc --version | awk '{ print $3; exit}')
case "$GCCVER" in
4.4*)	CC_FLAGS="-t GCC44";;
4.5*)	CC_FLAGS="-t GCC45";;
4.6*)	CC_FLAGS="-t GCC46";;
4.7*)	CC_FLAGS="-t GCC47";;
4.8*)	CC_FLAGS="-t GCC48";;
4.9*)	CC_FLAGS="-t GCC49";;
5.*)	CC_FLAGS="-t GCC5";;
6.*)	CC_FLAGS="-t GCC5";;
7.*)	CC_FLAGS="-t GCC5";;
8.*)	CC_FLAGS="-t GCC5";;
9.*)	CC_FLAGS="-t GCC5";;
1?.*)	CC_FLAGS="-t GCC5";;
esac

# parallel builds
SMP_MFLAGS="%{?_smp_mflags}"
if [[ x"$SMP_MFLAGS" = x-j* ]]; then
	CC_FLAGS="$CC_FLAGS -n ${SMP_MFLAGS#-j}"
elif [ -n "%{?jobs}" ]; then
	CC_FLAGS="$CC_FLAGS -n %{?jobs}"
fi

# prepare
make -C BaseTools

%ifarch x86_64
ovmf_build_iso()
{
	local ARCH="$1"
	local UEFI_BINDIR=$(
		echo -n Build/Ovmf${ARCH}/DEBUG_*/
		echo $ARCH | tr '[:lower:'] '[:upper:]'
	)
	local UEFI_SHELL_BINARY=$UEFI_BINDIR/Shell.efi
	local ENROLLER_BINARY=$UEFI_BINDIR/EnrollDefaultKeys.efi
	local UEFI_SHELL_IMAGE=uefi_shell_${ARCH}.img
	local ISO_IMAGE=OVMF/UefiShell.iso

	local UEFI_SHELL_BINARY_BNAME=$(basename -- "$UEFI_SHELL_BINARY")
	local UEFI_SHELL_SIZE=$(stat --format=%s -- "$UEFI_SHELL_BINARY")
	local ENROLLER_SIZE=$(stat --format=%s -- "$ENROLLER_BINARY")

	# add 1MB then 10% for metadata
	local UEFI_SHELL_IMAGE_KB=$((
		(UEFI_SHELL_SIZE + ENROLLER_SIZE +
		 1 * 1024 * 1024) * 11 / 10 / 1024
	))

	# create non-partitioned FAT image
	rm -f -- "$UEFI_SHELL_IMAGE"
	/usr/sbin/mkdosfs -C "$UEFI_SHELL_IMAGE" -n UEFI_SHELL -- "$UEFI_SHELL_IMAGE_KB"

	export MTOOLS_SKIP_CHECK=1
	mmd	-i "$UEFI_SHELL_IMAGE"				::efi
	mmd	-i "$UEFI_SHELL_IMAGE"				::efi/boot
	mcopy	-i "$UEFI_SHELL_IMAGE"	"$UEFI_SHELL_BINARY"	::efi/boot/bootx64.efi
	mcopy	-i "$UEFI_SHELL_IMAGE"	"$ENROLLER_BINARY"	::
	mdir	-i "$UEFI_SHELL_IMAGE"	-/			::

	# build ISO with FAT image file as El Torito EFI boot image
	genisoimage -input-charset ASCII -J -rational-rock \
		-efi-boot "$UEFI_SHELL_IMAGE" -no-emul-boot \
		-o "$ISO_IMAGE" -- "$UEFI_SHELL_IMAGE"
}

# build OVMF
for cfg in pure-efi pure-efi-debug secboot secboot-debug; do
	OVMF_FLAGS="$CC_FLAGS -D HTTP_BOOT_ENABLE -D FD_SIZE_4MB"

	case "$cfg" in
	pure-efi)
		# nothing
		;;
	pure-efi-debug)
		OVMF_FLAGS="$OVMF_FLAGS -D DEBUG_LOG_ENABLE"
		;;
	secboot)
		OVMF_FLAGS="$OVMF_FLAGS -D SECURE_BOOT_ENABLE"
		OVMF_FLAGS="$OVMF_FLAGS -D SMM_REQUIRE"
		OVMF_FLAGS="$OVMF_FLAGS -D TPM_ENABLE"
                OVMF_FLAGS="$OVMF_FLAGS -D SB_OPROM_VERIFY"
		OVMF_FLAGS="$OVMF_FLAGS -D EXCLUDE_SHELL_FROM_FD"
		;;
	secboot-debug)
		OVMF_FLAGS="$OVMF_FLAGS -D DEBUG_LOG_ENABLE"
		OVMF_FLAGS="$OVMF_FLAGS -D SECURE_BOOT_ENABLE"
		OVMF_FLAGS="$OVMF_FLAGS -D SMM_REQUIRE"
		OVMF_FLAGS="$OVMF_FLAGS -D TPM_ENABLE"
                OVMF_FLAGS="$OVMF_FLAGS -D SB_OPROM_VERIFY"
		OVMF_FLAGS="$OVMF_FLAGS -D EXCLUDE_SHELL_FROM_FD"
		;;
	esac

	build $OVMF_FLAGS -a X64 -p OvmfPkg/OvmfPkgX64.dsc
	mkdir -p "OVMF"
	cp Build/OvmfX64/DEBUG_*/FV/OVMF_CODE.fd OVMF/OVMF_CODE.${cfg}.fd
	cp Build/OvmfX64/DEBUG_*/FV/OVMF_VARS.fd OVMF/OVMF_VARS.${cfg}.fd
	if [ "$cfg" = secboot ] || [ "$cfg" = secboot-debug ]; then
		ovmf_build_iso X64
		# Enroll the default certificates in the variable store template.
		%{python_ver} ovmf-vars-generator --verbose --verbose \
		  --verbose --print-output \
		  --qemu-binary        /usr/libexec/qemu-kvm \
		  --ovmf-binary        OVMF_CODE.enrollment.fd \
		  --ovmf-template-vars OVMF/OVMF_VARS.${cfg}.fd \
		  --uefi-shell-iso     OVMF/UefiShell.iso \
		  --skip-testing \
		  OVMF_VARS.${cfg}.fd

		mv -f OVMF_VARS.${cfg}.fd OVMF/OVMF_VARS.${cfg}.fd

		# For secboot we want an additional var file named 'OVMF_VARS'
		# to be consistent with default OVMF package.
		if [ "$cfg" = secboot ]; then
			cp OVMF/OVMF_VARS.${cfg}.fd OVMF/OVMF_VARS.fd
		fi
	fi
	rm -rf Build/OvmfX64
done

%endif

%ifarch aarch64
aavmf_build_iso()
{
	local ARCH="$1"
	local UEFI_BINDIR=$(
		echo -n Build/ArmVirtQemu-${ARCH}/DEBUG_*/
		echo $ARCH | tr '[:lower:'] '[:upper:]'
	)
	local UEFI_SHELL_BINARY=$UEFI_BINDIR/Shell.efi
	local ENROLLER_BINARY=$UEFI_BINDIR/EnrollDefaultKeys.efi
	local UEFI_SHELL_IMAGE=uefi_shell_${ARCH}.img
	local ISO_IMAGE=AAVMF/UefiShell.iso

	local UEFI_SHELL_BINARY_BNAME=$(basename -- "$UEFI_SHELL_BINARY")
	local UEFI_SHELL_SIZE=$(stat --format=%s -- "$UEFI_SHELL_BINARY")
	local ENROLLER_SIZE=$(stat --format=%s -- "$ENROLLER_BINARY")

	# add 1MB then 10% for metadata
	local UEFI_SHELL_IMAGE_KB=$((
		(UEFI_SHELL_SIZE + ENROLLER_SIZE +
		 1 * 1024 * 1024) * 11 / 10 / 1024
	))

	# create non-partitioned FAT image
	rm -f -- "$UEFI_SHELL_IMAGE"
	/usr/sbin/mkdosfs -C "$UEFI_SHELL_IMAGE" -n UEFI_SHELL -- "$UEFI_SHELL_IMAGE_KB"

	export MTOOLS_SKIP_CHECK=1
	mmd	-i "$UEFI_SHELL_IMAGE"				::efi
	mmd	-i "$UEFI_SHELL_IMAGE"				::efi/boot
	mcopy	-i "$UEFI_SHELL_IMAGE"	"$UEFI_SHELL_BINARY"	::efi/boot/bootx64.efi
	mcopy	-i "$UEFI_SHELL_IMAGE"	"$ENROLLER_BINARY"	::
	mdir	-i "$UEFI_SHELL_IMAGE"	-/			::

	# build ISO with FAT image file as El Torito EFI boot image
	genisoimage -input-charset ASCII -J -rational-rock \
		-efi-boot "$UEFI_SHELL_IMAGE" -no-emul-boot \
		-o "$ISO_IMAGE" -- "$UEFI_SHELL_IMAGE"
}

# build AAVMF
#for cfg in pure-efi pure-efi-debug secboot secboot-debug; do
for cfg in pure-efi pure-efi-debug; do
	AAVMF_FLAGS="$CC_FLAGS -D HTTP_BOOT_ENABLE "

	case "$cfg" in
	pure-efi)
		AAVMF_FLAGS="$AAVMF_FLAGS -D DEBUG_PRINT_ERROR_LEVEL=0x80000000"
		;;
	pure-efi-debug)
		AAVMF_FLAGS="$AAVMF_FLAGS -D DEBUG_PRINT_ERROR_LEVEL=0x8040004F"
		;;
	secboot)
		AAVMF_FLAGS="$AAVMF_FLAGS -D DEBUG_PRINT_ERROR_LEVEL=0x80000000"
		AAVMF_FLAGS="$AAVMF_FLAGS -D SECURE_BOOT_ENABLE"
		AAVMF_FLAGS="$AAVMF_FLAGS -D TPM2_ENABLE"
		AAVMF_FLAGS="$AAVMF_FLAGS -D EXCLUDE_SHELL_FROM_FD"
		;;
	secboot-debug)
		AAVMF_FLAGS="$AAVMF_FLAGS -D DEBUG_PRINT_ERROR_LEVEL=0x8040004F"
		AAVMF_FLAGS="$AAVMF_FLAGS -D SECURE_BOOT_ENABLE"
		AAVMF_FLAGS="$AAVMF_FLAGS -D TPM2_ENABLE"
		AAVMF_FLAGS="$AAVMF_FLAGS -D EXCLUDE_SHELL_FROM_FD"
		;;
	esac

	build $AAVMF_FLAGS -a AARCH64 -p ArmVirtPkg/ArmVirtQemu.dsc
	mkdir -p "AAVMF"
	cp Build/ArmVirtQemu-AARCH64/DEBUG_*/FV/QEMU_EFI.fd AAVMF
	cp Build/ArmVirtQemu-AARCH64/DEBUG_*/FV/QEMU_VARS.fd AAVMF
	# Pad the binaries and name them similar to the standard AAVMF package
	cat AAVMF/QEMU_EFI.fd /dev/zero | head -c 64m > AAVMF/AAVMF_CODE.${cfg}.fd
	cat AAVMF/QEMU_VARS.fd /dev/zero | head -c 64m > AAVMF/AAVMF_VARS.${cfg}.fd
	rm AAVMF/QEMU_EFI.fd
	rm AAVMF/QEMU_VARS.fd
	if [ "$cfg" = secboot ] || [ "$cfg" = secboot-debug ] ; then
		aavmf_build_iso AARCH64
		# Enroll the default certificates in the variable store template.
		python aavmf-vars-generator --verbose --verbose \
		  --verbose --print-output \
		  --qemu-binary        /usr/libexec/qemu-kvm \
		  --ovmf-binary        AAVMF/AAVMF_CODE.secboot.fd \
		  --ovmf-template-vars AAVMF/AAVMF_VARS.${cfg}.fd \
		  --uefi-shell-iso     AAVMF/UefiShell.iso \
		  --skip-testing \
		  AAVMF_VARS.${cfg}.fd

		mv -f AAVMF_VARS.${cfg}.fd AAVMF/AAVMF_VARS.${cfg}.fd

		# For secboot we want an additional var file named 'AAVMF_VARS'
		# to be consistent with OVMF
		if [ "$cfg" = secboot ]; then
			cp AAVMF/AAVMF_VARS.${cfg}.fd AAVMF/AAVMF_VARS.fd
		fi
	fi
	rm -rf Build/ArmVirtQemu-AARCH64

done

%endif

%install

mkdir -p %{buildroot}%{_bindir}
install	--strip \
	BaseTools/Source/C/bin/EfiRom \
	BaseTools/Source/C/bin/VolInfo \
	%{buildroot}%{_bindir}

# Install License files
%ifarch x86_64
mkdir -p %{buildroot}/%{_docdir}/OVMF/Licenses
cp -a OvmfPkg/License.txt %{buildroot}/%{_docdir}/OVMF/Licenses/OvmfPkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/OVMF/Licenses/edk2-License.txt
cp -a CryptoPkg/Library/OpensslLib/openssl/LICENSE %{buildroot}/%{_docdir}/OVMF/Licenses/OpensslLib-License.txt
%endif
%ifarch aarch64
mkdir -p %{buildroot}/%{_docdir}/AAVMF/Licenses
cp -a OvmfPkg/License.txt %{buildroot}/%{_docdir}/AAVMF/Licenses/OvmfPkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/AAVMF/Licenses/FatPkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/AAVMF/Licenses/IntelFrameworkModulePkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/AAVMF/Licenses/MdeModulePkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/AAVMF/Licenses/MdePkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/AAVMF/Licenses/OptionRomPkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/AAVMF/Licenses/ShellPkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/AAVMF/Licenses/ArmPkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/AAVMF/Licenses/ArmPlatformPkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/AAVMF/Licenses/EmbeddedPkg-License.txt
%endif

%ifarch x86_64
mkdir -p %{buildroot}/usr/share/OVMF
cp -a OVMF/* %{buildroot}/usr/share/OVMF
cp -a OvmfPkg/README %{buildroot}/%{_docdir}/OVMF
cp -a OVMF-ol8-changelog.txt %{buildroot}/%{_docdir}/OVMF
%endif
%ifarch aarch64
mkdir -p %{buildroot}/usr/share/AAVMF
cp -a AAVMF/* %{buildroot}/usr/share/AAVMF
cp -a AAVMF-ol8-changelog.txt %{buildroot}/%{_docdir}/AAVMF
%endif

%files tools
%doc BaseTools/UserManuals/EfiRom_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/VolInfo_Utility_Man_Page.rtf
%{_bindir}/*

%defattr(-,root,root,-)

%ifarch x86_64
%files ovmf 
%dir /usr/share/OVMF
/usr/share/OVMF
%endif

%ifarch aarch64
%files aarch64
%dir /usr/share/AAVMF
/usr/share/AAVMF
%endif


%ifarch x86_64
%dir %{_docdir}/OVMF/Licenses
%doc %{_docdir}/OVMF/Licenses/OvmfPkg-License.txt
%doc %{_docdir}/OVMF/Licenses/OpensslLib-License.txt
%doc %{_docdir}/OVMF/Licenses/edk2-License.txt
%doc %{_docdir}/OVMF/README
%doc %{_docdir}/OVMF/OVMF-ol8-changelog.txt
%endif

%ifarch aarch64
%dir %{_docdir}/AAVMF/Licenses
%doc %{_docdir}/AAVMF/Licenses/OvmfPkg-License.txt
%doc %{_docdir}/AAVMF/Licenses/FatPkg-License.txt
%doc %{_docdir}/AAVMF/Licenses/IntelFrameworkModulePkg-License.txt
%doc %{_docdir}/AAVMF/Licenses/MdeModulePkg-License.txt
%doc %{_docdir}/AAVMF/Licenses/MdePkg-License.txt
%doc %{_docdir}/AAVMF/Licenses/OptionRomPkg-License.txt
%doc %{_docdir}/AAVMF/Licenses/ArmPkg-License.txt
%doc %{_docdir}/AAVMF/Licenses/ArmPlatformPkg-License.txt
%doc %{_docdir}/AAVMF/Licenses/EmbeddedPkg-License.txt
%doc %{_docdir}/AAVMF/Licenses/ShellPkg-License.txt
%doc %{_docdir}/AAVMF/AAVMF-ol8-changelog.txt
%endif


%changelog
* Thu Dec 3 2020 Aaron Young <Aaron.Young@oracle.com> - 1:20201203-1.el8
- Updates for OVMF/AAVMF Version 1.4.1

* Thu Dec 03 2020 Aaron Young <aaron.young@oracle.com>
- Create new 20201203 release for OL8
* Wed Nov 18 2020 Aaron Young <aaron.young@oracle.com>
- Create new 20201118 release for OL8 which includes the following fixed CVEs:
  {CVE-2019-14584} {CVE-2019-14562} {CVE-2019-11098} {CVE-2019-14559} {CVE-2019-14575} {CVE-2019-14559} {CVE-2019-14587} {CVE-2019-14558} {CVE-2019-14586} {CVE-2019-14563}
* Sat Oct 10 2020 Aaron Young <aaron.young@oracle.com>
-  Create new 20201010 release for OL8
* Wed Oct 7 2020 Aaron Young <aaron.young@oracle.com>
- Create new 20201007 release for OL8
* Fri Jul 31 2020 Aaron Young <aaron.young@oracle.com>
- Create new 20200731 release for OL8
* Fri May 1 2020 Aaron Young <aaron.young@oracle.com>
- Create new 20200501 release for OL8
* Fri Mar 13 2020 Aaron Young <aaron.young@oracle.com>
- Create new 20200313(1.3) release for OL8 which includes the following fixed CVEs:
  {CVE-2018-12182} {CVE-2019-13224} {CVE-2019-13225} {CVE-2019-14553}
* Wed Oct 02 2019 Aaron Young <aaron.young@oracle.com>
- Create new 1.2 release for OL8 which includes the following fixed CVEs:
  {CVE-2017-5715} {CVE-2017-5731} {CVE-2017-5732} {CVE-2017-5733} {CVE-2017-5734} {CVE-2017-5735} {CVE-2017-5753} {CVE-2018-12178} {CVE-2018-12180} {CVE-2018-12181} {CVE-2018-3630}
